window.Gleam.initSearch([{"doc":"stacky","title":"stacky","content":"# Stacky ☆ BEAM stack trace in Gleam\n\n![Erlang-compatible](https://img.shields.io/badge/target-erlang-b83998)\n&lt;a href=&quot;https://hexdocs.pm/stacky&quot;&gt;&lt;img src=&quot;https://img.shields.io/badge/hex-docs-ffaff3&quot; alt=&quot;Documentation&quot; /&gt;&lt;/a&gt;\n&lt;a href=&quot;https://hex.pm/packages/stacky&quot;&gt;&lt;img src=&quot;https://img.shields.io/hexpm/v/stacky&quot; alt=&quot;Available on Hex&quot; /&gt;&lt;/a&gt;\n![CI](https://github.com/inoas/stacky/actions/workflows/test.yml/badge.svg?branch=main)\n&lt;a href=&quot;https://discord.gg/Fm8Pwmy&quot;&gt;&lt;img src=&quot;https://img.shields.io/discord/768594524158427167?color=blue&quot; alt=&quot;Discord chat&quot;&gt;&lt;/a&gt;\n\n**A stack trace of stack frames with module name, function name, arity, file name and line number!**\n\n## Installation\n\n```shell\ngleam add stacky\n```\n\n## Usage\n\n```gleam\nlet stacktrace = stacky.trace()\n\nio.print(&quot;\\n&quot;)\n\nio.println(&quot;Trace to string:&quot;)\nstacktrace\n|&gt; stacky.print_trace\n\nio.print(&quot;\\n&quot;)\n\nio.println(&quot;Frame with context:&quot;)\nstackframe\n|&gt; stacky.print_frame_with(context: #(&quot;my_context&quot;))\n```\n\n`stdout` example:\n\n```plaintext\nTrace to string:\n# 06\tmain() of src/stacky/internal/examples/example_readme.gleam\n    \tin /SOME_PATH/stacky/build/dev/erlang/stacky/_gleam_artefacts/stacky@internal@examples@example_readme.erl:8\n# 05\tstacky@@main:run/1\n    \tin /SOME_PATH/stacky/build/dev/erlang/stacky/_gleam_artefacts/stacky@@main.erl:11\n# 04\terl_eval:do_apply/7\n    \tin erl_eval.erl:746\n# 03\tinit:start_it/1\n# 02\tinit:start_em/1\n# 01\tinit:do_boot/3\n\nFrame with context:\n# 06\tmain() of src/stacky/internal/examples/example_readme.gleam\n    \tin /SOME_PATH/stacky/build/dev/erlang/stacky/_gleam_artefacts/stacky@internal@examples@example_readme.erl:8\nwith context: #(&quot;my_context&quot;)\n```\n\n## Demos\n\n```shell\ngleam run --module stacky/internal/examples/example_1\ngleam run --module stacky/internal/examples/example_2\ngleam run --module stacky/internal/examples/example_3\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/stacky&gt;.\n","url":"index.html"},{"doc":"stacky","title":"ErlangFileName","content":"pub type ErlangFileName {\n  ErlangFileName(String)\n}\n\nErlangFileName(String)\n\n\nSynonyms:\nstacky.ErlangFileName\nstacky ErlangFileName","url":"stacky.html#ErlangFileName"},{"doc":"stacky","title":"ErlangLineNumber","content":"pub type ErlangLineNumber {\n  ErlangLineNumber(Int)\n}\n\nErlangLineNumber(Int)\n\n\nSynonyms:\nstacky.ErlangLineNumber\nstacky ErlangLineNumber","url":"stacky.html#ErlangLineNumber"},{"doc":"stacky","title":"ErlangModuleName","content":"pub type ErlangModuleName {\n  ErlangModuleName(String)\n}\n\nErlangModuleName(String)\n\n\nSynonyms:\nstacky.ErlangModuleName\nstacky ErlangModuleName","url":"stacky.html#ErlangModuleName"},{"doc":"stacky","title":"FunctionArity","content":"pub type FunctionArity {\n  FunctionArity(Int)\n}\n\nFunctionArity(Int)\n\n\nSynonyms:\nstacky.FunctionArity\nstacky FunctionArity","url":"stacky.html#FunctionArity"},{"doc":"stacky","title":"FunctionName","content":"pub type FunctionName {\n  FunctionName(String)\n}\n\nFunctionName(String)\n\n\nSynonyms:\nstacky.FunctionName\nstacky FunctionName","url":"stacky.html#FunctionName"},{"doc":"stacky","title":"StackFrame","content":"pub type StackFrame {\n  StackFrame(\n    index: StackIndex,\n    erlang_module_name: ErlangModuleName,\n    function_name: FunctionName,\n    function_arity: FunctionArity,\n    erlang_file_name: ErlangFileName,\n    erlang_line_number: ErlangLineNumber,\n  )\n}\n\nStackFrame(\n  index: StackIndex,\n  erlang_module_name: ErlangModuleName,\n  function_name: FunctionName,\n  function_arity: FunctionArity,\n  erlang_file_name: ErlangFileName,\n  erlang_line_number: ErlangLineNumber,\n)\n\n\nSynonyms:\nstacky.StackFrame\nstacky StackFrame","url":"stacky.html#StackFrame"},{"doc":"stacky","title":"StackIndex","content":"pub type StackIndex {\n  StackIndex(Int)\n}\n\nStackIndex(Int)\n\n\nSynonyms:\nstacky.StackIndex\nstacky StackIndex","url":"stacky.html#StackIndex"},{"doc":"stacky","title":"StackTrace","content":"pub type StackTrace {\n  StackTrace(List(StackFrame))\n}\n\nStackTrace(List(StackFrame))\n\n\nSynonyms:\nstacky.StackTrace\nstacky StackTrace","url":"stacky.html#StackTrace"},{"doc":"stacky","title":"erlang_file_name","content":"pub fn erlang_file_name(stack_frame: StackFrame) -&gt; String\n Gets the erlang file name of the stack frame.\n\nSynonyms:\nstacky.erlang_file_name\nstacky erlang_file_name","url":"stacky.html#erlang_file_name"},{"doc":"stacky","title":"erlang_line_number","content":"pub fn erlang_line_number(stack_frame: StackFrame) -&gt; Int\n Gets the ang erlline number of the stack frame.\n\nSynonyms:\nstacky.erlang_line_number\nstacky erlang_line_number","url":"stacky.html#erlang_line_number"},{"doc":"stacky","title":"erlang_module_name","content":"pub fn erlang_module_name(stack_frame: StackFrame) -&gt; String\n Gets the erlang module name of the stack frame.\n\nSynonyms:\nstacky.erlang_module_name\nstacky erlang_module_name","url":"stacky.html#erlang_module_name"},{"doc":"stacky","title":"frame","content":"pub fn frame(stack_trace: StackTrace, index: Int) -&gt; StackFrame\n Gets the stack frame at the given 0-based list index\n where `0` is the last stack frame and `1` is the\n second-to-last stack frame and `size(stack_trace) - 1`\n is the first stack frame.\n\n The StackFrame itself has an inverse index field\n that represents the index of the frame within the stack.\n see `frame_by_stack_index`.\n\nSynonyms:\nstacky.frame\nstacky frame","url":"stacky.html#frame"},{"doc":"stacky","title":"frame_by_stack_index","content":"pub fn frame_by_stack_index(\n  stack_trace: StackTrace,\n  index: Int,\n) -&gt; StackFrame\n Gets the stack frame at the given 1-based stack index,\n where `1` is the first stack frame, `2` is the second stack frame,\n and size(stack_trace) is the last stack frame.\n\nSynonyms:\nstacky.frame_by_stack_index\nstacky frame_by_stack_index","url":"stacky.html#frame_by_stack_index"},{"doc":"stacky","title":"frame_to_string","content":"pub fn frame_to_string(stack_frame: StackFrame) -&gt; String\n Converts a stack frame to a string.\n\nSynonyms:\nstacky.frame_to_string\nstacky frame_to_string","url":"stacky.html#frame_to_string"},{"doc":"stacky","title":"function_arity","content":"pub fn function_arity(stack_frame: StackFrame) -&gt; Int\n Gets the function arity of the stack frame.\n\nSynonyms:\nstacky.function_arity\nstacky function_arity","url":"stacky.html#function_arity"},{"doc":"stacky","title":"function_name","content":"pub fn function_name(stack_frame: StackFrame) -&gt; String\n Gets the function name of the stack frame.\n\nSynonyms:\nstacky.function_name\nstacky function_name","url":"stacky.html#function_name"},{"doc":"stacky","title":"main","content":"pub fn main() -&gt; Nil\n This is a library and the main function\n exists as a placeholder if called as a function\n from the command line.\n\nSynonyms:\nstacky.main\nstacky main","url":"stacky.html#main"},{"doc":"stacky","title":"print_frame","content":"pub fn print_frame(stack_frame: StackFrame) -&gt; Nil\n Print a stack frame.\n\nSynonyms:\nstacky.print_frame\nstacky print_frame","url":"stacky.html#print_frame"},{"doc":"stacky","title":"print_frame_with","content":"pub fn print_frame_with(\n  stack_frame: StackFrame,\n  context c: a,\n) -&gt; Nil\n Print a stack frame with context.\n\nSynonyms:\nstacky.print_frame_with\nstacky print_frame_with","url":"stacky.html#print_frame_with"},{"doc":"stacky","title":"print_trace","content":"pub fn print_trace(stack_trace: StackTrace) -&gt; Nil\n Print a stack trace.\n\nSynonyms:\nstacky.print_trace\nstacky print_trace","url":"stacky.html#print_trace"},{"doc":"stacky","title":"print_trace_with","content":"pub fn print_trace_with(\n  stack_trace: StackTrace,\n  context c: a,\n) -&gt; Nil\n Print a stack trace with context.\n\nSynonyms:\nstacky.print_trace_with\nstacky print_trace_with","url":"stacky.html#print_trace_with"},{"doc":"stacky","title":"qualified_module_name","content":"pub fn qualified_module_name(stack_frame: StackFrame) -&gt; String\n Gets the qualified module name from the erlang stack frame.\n\n In case the module name contains `@` (but no `@@`),\n those will be replaced with `/` to form a qualified module name.\n\nSynonyms:\nstacky.qualified_module_name\nstacky qualified_module_name","url":"stacky.html#qualified_module_name"},{"doc":"stacky","title":"size","content":"pub fn size(stack_trace: StackTrace) -&gt; Int\n Calculates the stack trace size.\n\nSynonyms:\nstacky.size\nstacky size","url":"stacky.html#size"},{"doc":"stacky","title":"stack_index","content":"pub fn stack_index(stack_frame: StackFrame) -&gt; Int\n Gets the stack index within its parent stack frame.\n\nSynonyms:\nstacky.stack_index\nstacky stack_index","url":"stacky.html#stack_index"},{"doc":"stacky","title":"trace","content":"pub fn trace() -&gt; StackTrace\n Gets the stack trace of the current process.\n\nSynonyms:\nstacky.trace\nstacky trace","url":"stacky.html#trace"},{"doc":"stacky","title":"trace_to_string","content":"pub fn trace_to_string(stack_frame: StackTrace) -&gt; String\n Converts a stack trace to a string.\n\nSynonyms:\nstacky.trace_to_string\nstacky trace_to_string","url":"stacky.html#trace_to_string"},{"doc":"stacky","title":"stacky","content":"","url":"stacky.html"}]);